#include<bits/stdc++.h>
using namespace std;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, q, x, kom, u, v;
    int  jed=0, nul = 0;
    cin>>n;
    vector<int> a;
    vector<int> k;
    for(int i=0; i<n; i++){
        cin>>x;
        if(x==1) jed++;
        else if(x==0) nul++;
        a.push_back(x);
    }
    for(int i=0; i<n; i++){
        x=a[i];
        k.push_back(x);

    }
    cin>>q;
    int i, j;
    if(jed + nul == n){
    for(int w=0; w<q; w++){
        cin>>kom;
        if(kom==0){
            cin>>i;
            if (i<=jed) cout<<1<<endl;
            else cout<<0<<endl;
            
        }
        else{
            cin>>i>>x;
            if(a[i-1]!=x){
                a[i-1]=x;
                if (x==0) jed--;
                else jed++;

            }
        }


    }}
    else {
    for(int w=0; w<q; w++){ 
        cin>>kom;
        if(kom==0){
            cin>>u;
            u--;
            for(i=0; i<n; i++){
                k[i] = a[i];  }
                
            sort(k.rbegin(), k.rend());
            for( i=0; i<n-1; i++){
                if(k[i]==0) break;
            for( j=i+1; j<n; j++){
                if(k[j]==0){j=n;}
                else if(k[i]<(k[i]|k[j])){
                    x= k[i];
                    k[i] = (k[i]|k[j]);
                    k[j] = (x & k[j]);
            }
            }
            }
            sort(k.rbegin(), k.rend());

            cout<<k[u]<<endl;
        }
        else{
            cin>>u>>x;
            u--;
            if(a[u]!=x){
                a[u]=x;
                

            

            }
        }


    }
    }

}